# Subclass
Consider classes to represent shapes such as 
`circle`, `square`, `cube`, `rectangle`, `triangle`

- How would you classify them? 
- What actions will you take on these shapes? 

## Actions
- compute area  -> getArea()
- translate shape -> translate(std::vector) #  (x, y) or (x, y, z)
- scale shape -> scale(factor);   # factor > 0)
- shape representation
  - circle: center  (std::vector), radius (float)
  - square: edge length
  - rectangle: width, height

## Subclass
- Is a rectangle a type of square? 
- Is a square a type of rectangle? 
- Ask yourself: 
    - Whatever I do on a square, can I do it on the rectangle? 
    - Whatever I do on a rectangl, can I do it on a square?

- Question: 
    - is a circle a type of square? Answer: No
    - is a circle a shape? Answer yes

## Subclass characteristics
    - a subclass has all the same attributes as a class + additional attributes
    - a subclass has all the functionality of a class + additional functionality

## Examples of subclass hierarchies
